//
// PovRay scene file for a sci-fi power supply
//
// Author:   Hj. Malthaner
// Email:    hansjoerg.malthaner@gmx.de
// Date:   2011/12/22
//
// Web:      http://opengameart.org/users/varkalandar
//
// This file is available under the GNU general
// public license v2 or newer.
//
// http://www.gnu.org/licenses/gpl-2.0.html
//

global_settings 
{
	max_trace_level 200
}

#declare Cam1 = 
camera 
{
 	orthographic
	location <2.5, 2.5*0.82, 2.5>*1.4
	look_at <0, 0, 0>
}            

camera 
{ 
	Cam1 
}          

light_source 
{ 
	<2.5*20, 100, 2.5*10>
	color rgb <1, 1, 1> 
}

// sky sphere

sphere 
{
	<0,0,0>, 10000

	hollow

	pigment 
  {
    color rgb 1
	}
}	

#declare FM = 3.0;

#declare FLOOR = box 
{
	<-1*FM, 0.0, -1*FM>,
	<1*FM, -0.3, 1*FM>

	texture 
  {
    pigment
    {
      color rgb <0.2, 0.3, 0.2>
      quick_color rgb 1
    }

    normal 
    {
      bumps 0.1
      scale 0.5                
    }

    finish 
    {
      ambient 0.2
      diffuse 0.8
		}
	}
}

#declare TEX_BASE =
texture
{
  pigment 
  {
    color rgb <0.59, 0.57, 0.55>
		quick_color 1
  }
  normal
  {
    granite 0.03
    scale 0.005
  }
  finish
  {
    ambient 0.1
    diffuse 0.35
    specular 0.05
    roughness 0.2
  }
}

#declare TEX_CHROME =
texture
{
  pigment 
  {
    color rgbt <0.99, 0.5, 0.2, 0.6>
		quick_color 1
  }
  normal
  {
    marble 0.5
    scale 0.01
    rotate <90, 0, 0>
  }
  finish
  {
    ambient 0.05
    diffuse 0.3
    specular 0.34
    roughness 0.1
    reflection 0.4
    metallic
  }
}

#declare TEX_COPPER =
texture
{
  pigment 
  {
    color rgbt <0.99, 0.33, 0.2, 0.5>
		quick_color 1
  }
  normal
  {
    bozo 0.1
    scale 0.05
  }
  finish
  {
    ambient 0.1
    diffuse 0.3
    specular 0.3
    roughness 0.15
    reflection 0.2
    metallic
  }
}


#declare TEX_BLACK_GLASS =
texture 
{
  pigment 
  {
    bozo
    color_map
    {
      [0.1 color rgb <0.1, 0.1, 0.1>]
      [0.9 color rgb <0.1, 0.1, 0.11>]
    }
		quick_color 1
    
    scale 0.001
  }
  normal
  {
    bozo 0.05
    scale 0.01
  }
  finish
  {
    ambient 0.04
    diffuse 0.3
    specular 0.3
    roughness 0.05
    reflection 0.05
  }    
}

#declare TEX_GLASS_STAND_TUBE =
texture
{
  pigment 
  {
    bozo
    color_map
    {
      [0.6 color rgbf <0.97, 0.98, 0.97, 0.98>]
      [0.7 color rgbf <0.96, 0.97, 0.96, 0.97>]
    }

    scale 0.2
  }
  finish
  {
    ambient 0.01
    diffuse 0.1
    specular 0.4
    roughness 0.04
    reflection {0.02, 0.12}
  }    
}


#declare O_STAND_TUBE_BASE =
cylinder
{
  <0, 0, 0>, <0, 1, 0>, 0.3
}

#declare O_STAND_TUBE =
difference
{
  merge 
  {
    object
    {
      O_STAND_TUBE_BASE
    }
    
    cylinder
    {
      <0, 0.0000001, 0>, <0, 0.0301, 0>, 0.5
    }
    difference
    {
      cylinder
      {
        <0, 0, 0 >, <0, 0.03, 0>, 0.3+0.03
      }
      torus
      {
        0.3+0.03, 0.03
        translate <0, 0.03, 0>
      }
      translate <0, 0.02, 0>
    }
  }
  object
  {
    O_STAND_TUBE_BASE
    scale <0.92, 1, 0.92>
    translate <0, 0.03, 0>
  }
  texture 
  {
    TEX_GLASS_STAND_TUBE
  }
  interior
  {
    ior 1.4
  }
  bounded_by
  {
    cone
    {
      <0,-0.0001, 0>, 1.1, <0, 1.00001, 0>, 0.31
    }
  }
}

#declare O_GLASS_BELL_BASE =
merge
{
  cylinder
  {
    <0, 0, 0>, <0, 1, 0>, 0.5
  }
  sphere
  {
    <0, 0, 0>, 0.5
    scale <1, 0.6, 1>
    translate <0, 1, 0>
  }
}

#declare O_GLASS_BELL =
difference
{
  merge 
  {
    object
    {
      O_GLASS_BELL_BASE
      scale 0.95
    }
    
    cylinder
    {
      <0,0.0000001,0>, <0, 0.02, 0>, 0.5
    }
    difference
    {
      cylinder
      {
        <0, 0, 0 >, <0, 0.02, 0>, 0.5*0.95+0.02
      }
      torus
      {
        0.5*0.95+0.02, 0.02
        translate <0, 0.02, 0>
      }
      translate <0, 0.02, 0>
    }
  }
  merge 
  {
    object
    {
      O_GLASS_BELL_BASE
      scale <0.93, 0.94, 0.93>
      translate <0, -0.001, 0>
    }
    object
    {
      O_GLASS_BELL_BASE
      scale 0.93
      translate <0, -0.3, 0>
    }
  }
  texture 
  {
    pigment 
    {
      bozo
      color_map
      {
        [0.6 color rgbf <0.97, 0.98, 0.97, 0.998>]
        [0.7 color rgbf <0.96, 0.97, 0.96, 0.997>]
      }
  
      scale 0.2
    }
    finish
    {
      ambient 0.01
      diffuse 0.05
      specular 0.25
      roughness 0.04
      reflection {0.01, 0.1}
    }    
  }
  interior
  {
    ior 1.4
  }
}


#declare O_ONE_POLE =
union 
{
  object
  {
    O_GLASS_BELL_BASE
    scale <0.10, 0.26, 0.10>
  }
  
  torus
  {
    0.07, 0.02
    translate <0, 0.2, 0>
    texture { TEX_BASE }
  }
}


#declare O_ONE_TUBE =
union
{
  difference 
  {
    cylinder
    {
      <0,0,0>, <0, 2.0, 0>, 0.073 
    }
    cylinder
    {
      <0,0,0>, <0, 2.0, 0>, 0.066
    }
  }  
  
  sphere
  {
    0, 0.02
    translate <0, 2, 0>
  }
  
  sphere
  {
    0, 1
    scale <0.02, 2.0 - 0.9, 0.02>
    translate <0, 2.0/2, 0>
    texture
    {
      TEX_GLASS_STAND_TUBE
      pigment
      {
        granite
        scale 0.1

        color_map
        {
          [0.0  color rgbt <0.5, 0.6, 0.7, 1>]
          [1.0  color rgbt <1, 1, 1, 0.9>]
        }
				quick_color 1
      }
      normal 
      {
        granite 0.5
        scale 0.1
      }
    }
  }

  light_source
  {
    <0, 0.40, 0>
    color rgb <0.07, 0.04, 0.1>*5
   
    fade_distance 1
    fade_power 2

    photons
    {
      reflection on
      refraction on
    }  
  }
  light_source
  {
    <0, 2-0.40, 0>
    color rgb <0.07, 0.04, 0.1>*5
   
    fade_distance 1
    fade_power 2

    photons
    {
      reflection on
      refraction on
    }  
  }
}

#declare O_FOUR_POLES =
union 
{
  object
  {
    O_ONE_POLE
    translate <-0.38, 0, -0.38>
  }
  object
  {
    O_ONE_POLE
    translate <-0.38, 0, 0.38>
  }
  object
  {
    O_ONE_POLE
    translate <0.38, 0, -0.38>
  }
  object
  {
    O_ONE_POLE
    translate <0.38, 0, 0.38>
  }
}

#declare O_FOUR_TUBE_POLES =
union
{
  union
  {
    object
    {
      O_FOUR_POLES
    }
    texture { TEX_COPPER }
  }
  
  union
  {
    object
    {
      O_ONE_TUBE
      translate <-0.38, 0, -0.38>
    }
    object
    {
      O_ONE_TUBE
      translate <-0.38, 0, 0.38>
    }
    object
    {
      O_ONE_TUBE
      translate <0.38, 0, -0.38>
    }
    object
    {
      O_ONE_TUBE
      translate <0.38, 0, 0.38>
    }
    texture
    {
      TEX_GLASS_STAND_TUBE
      pigment
      {
        crackle
        scale <0.5, 3, 0.5>*0.3
        turbulence 1.2

        color_map
        {
          [0.0  color rgbf <0.97, 0.99, 1.00, 0.94>]
          [0.30 color rgbf <0.90, 0.94, 0.99, 0.97>]
          [1.0  color rgbf <0.45, 0.60, 0.90, 0.99>]
        }
				quick_color 1
      }
    }
    translate <0, 0.2, 0>
  }
}

union
{
  
  union
  {
    // power
    box 
    {
      <-1, 0, -1>,
      <1, 0.2, 1>
    }
    
    union 
    {
      union
      {
        cylinder
        {
          <0, 0.2, 0>, <0, 0.22, 0>, 0.38
        }
        cylinder
        {
          <0, 0.22, 0>, <0, 0.25, 0>, 0.27
        }
				merge
				{
          union 
          {
            sphere
            {
              0, 1
              scale 0.55
              translate <0, 2.9, 0>
              texture { TEX_CHROME }
            }
            sphere
            {
              0, 1
              scale 0.25
              translate <0, 2.9, 0>
              texture { TEX_COPPER }
            }
          }
					cylinder
					{
						<0,0,0>, <0, 2.6, 0>, 0.2
						texture { TEX_CHROME rotate <0, 0, 90>}
					}
				}
				interior {ior 1.4}
			}
			
      union 
      {
        #local n = 0;
        #while(n<15)
          torus
          {
            0.3, 0.03
            scale <1+sin(n+2)*0.1, 1, 1+sin(n+2)*0.1>
            translate <0, 0.2 + 2.3/2 + (n-7)/7 * 0.93, 0>
          }
          torus
          {
            0.3, 0.05
            scale <1+sin(n+2)*0.1, 0.4, 1+sin(n+2)*0.1>
            translate <0, 0.2 + 2.3/2 + (n-7)/7 * 0.93, 0>
          }

#local n = n + 1;
        #end
        texture { TEX_COPPER }
				interior {ior 1.4}
      }
    }
    
    object
    {
      O_FOUR_TUBE_POLES
    }
    
    texture
    {
      TEX_BASE
    }
  }

  translate <2, 0, 2>
}